Index: uspace/drv/bus/usb/usbmast/main.c
===================================================================
--- uspace/drv/bus/usb/usbmast/main.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/usbmast/main.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -55,5 +55,5 @@
 #define GET_BULK_OUT(dev) ((dev)->pipes[BULK_OUT_EP].pipe)
 
-static usb_endpoint_description_t bulk_in_ep = {
+static const usb_endpoint_description_t bulk_in_ep = {
 	.transfer_type = USB_TRANSFER_BULK,
 	.direction = USB_DIRECTION_IN,
@@ -63,5 +63,5 @@
 	.flags = 0
 };
-static usb_endpoint_description_t bulk_out_ep = {
+static const usb_endpoint_description_t bulk_out_ep = {
 	.transfer_type = USB_TRANSFER_BULK,
 	.direction = USB_DIRECTION_OUT,
@@ -72,5 +72,5 @@
 };
 
-usb_endpoint_description_t *mast_endpoints[] = {
+static const usb_endpoint_description_t *mast_endpoints[] = {
 	&bulk_in_ep,
 	&bulk_out_ep,
@@ -82,10 +82,46 @@
     void *arg);
 
+/** Callback when a device is removed from the system.
+ *
+ * @param dev Representation of USB device.
+ * @return Error code.
+ */
+static int usbmast_device_gone(usb_device_t *dev)
+{
+	usbmast_dev_t *mdev = dev->driver_data;
+	assert(mdev);
+
+	for (size_t i = 0; i < mdev->lun_count; ++i) {
+		const int rc = ddf_fun_unbind(mdev->luns[i]);
+		if (rc != EOK) {
+			usb_log_error("Failed to unbind LUN function %zu: "
+			    "%s\n", i, str_error(rc));
+			return rc;
+		}
+		ddf_fun_destroy(mdev->luns[i]);
+		mdev->luns[i] = NULL;
+	}
+	free(mdev->luns);
+	return EOK;
+}
+
+/** Callback when a device is about to be removed.
+ *
+ * @param dev Representation of USB device.
+ * @return Error code.
+ */
+static int usbmast_device_remove(usb_device_t *dev)
+{
+	//TODO: flush buffers, or whatever.
+	//TODO: remove device
+	return ENOTSUP;
+}
+
 /** Callback when new device is attached and recognized as a mass storage.
  *
- * @param dev Representation of a the USB device.
+ * @param dev Representation of USB device.
  * @return Error code.
  */
-static int usbmast_add_device(usb_device_t *dev)
+static int usbmast_device_add(usb_device_t *dev)
 {
 	int rc;
@@ -94,9 +130,8 @@
 
 	/* Allocate softstate */
-	mdev = calloc(1, sizeof(usbmast_dev_t));
+	mdev = usb_device_data_alloc(dev, sizeof(usbmast_dev_t));
 	if (mdev == NULL) {
 		usb_log_error("Failed allocating softstate.\n");
-		rc = ENOMEM;
-		goto error;
+		return ENOMEM;
 	}
 
@@ -104,17 +139,22 @@
 	mdev->usb_dev = dev;
 
-	usb_log_info("Initializing mass storage `%s'.\n",
-	    dev->ddf_dev->name);
-	usb_log_debug(" Bulk in endpoint: %d [%zuB].\n",
-	    dev->pipes[BULK_IN_EP].pipe->endpoint_no,
-	    (size_t) dev->pipes[BULK_IN_EP].descriptor->max_packet_size);
+	usb_log_info("Initializing mass storage `%s'.\n", dev->ddf_dev->name);
+	usb_log_debug("Bulk in endpoint: %d [%zuB].\n",
+	    dev->pipes[BULK_IN_EP].pipe.endpoint_no,
+	    dev->pipes[BULK_IN_EP].pipe.max_packet_size);
 	usb_log_debug("Bulk out endpoint: %d [%zuB].\n",
-	    dev->pipes[BULK_OUT_EP].pipe->endpoint_no,
-	    (size_t) dev->pipes[BULK_OUT_EP].descriptor->max_packet_size);
+	    dev->pipes[BULK_OUT_EP].pipe.endpoint_no,
+	    dev->pipes[BULK_OUT_EP].pipe.max_packet_size);
 
 	usb_log_debug("Get LUN count...\n");
-	mdev->luns = usb_masstor_get_lun_count(mdev);
-
-	for (i = 0; i < mdev->luns; i++) {
+	mdev->lun_count = usb_masstor_get_lun_count(mdev);
+	mdev->luns = calloc(mdev->lun_count, sizeof(ddf_fun_t*));
+	if (mdev->luns == NULL) {
+		rc = ENOMEM;
+		usb_log_error("Failed allocating luns table.\n");
+		goto error;
+	}
+
+	for (i = 0; i < mdev->lun_count; i++) {
 		rc = usbmast_fun_create(mdev, i);
 		if (rc != EOK)
@@ -124,7 +164,16 @@
 	return EOK;
 error:
-	/* XXX Destroy functions */
-	if (mdev != NULL)
-		free(mdev);
+	/* Destroy functions */
+	for (size_t i = 0; i < mdev->lun_count; ++i) {
+		if (mdev->luns[i] == NULL)
+			continue;
+		const int rc = ddf_fun_unbind(mdev->luns[i]);
+		if (rc != EOK) {
+			usb_log_warning("Failed to unbind LUN function %zu: "
+			    "%s.\n", i, str_error(rc));
+		}
+		ddf_fun_destroy(mdev->luns[i]);
+	}
+	free(mdev->luns);
 	return rc;
 }
@@ -158,8 +207,6 @@
 	}
 
-	free(fun_name);
-
 	/* Allocate soft state */
-	mfun = ddf_dev_data_alloc(mdev->ddf_dev, sizeof(usbmast_fun_t));
+	mfun = ddf_fun_data_alloc(fun, sizeof(usbmast_fun_t));
 	if (mfun == NULL) {
 		usb_log_error("Failed allocating softstate.\n");
@@ -168,12 +215,10 @@
 	}
 
+	mfun->ddf_fun = fun;
 	mfun->mdev = mdev;
 	mfun->lun = lun;
 
-	fun_name = NULL;
-
 	/* Set up a connection handler. */
 	fun->conn_handler = usbmast_bd_connection;
-	fun->driver_data = mfun;
 
 	usb_log_debug("Inquire...\n");
@@ -219,4 +264,7 @@
 		goto error;
 	}
+
+	free(fun_name);
+	mdev->luns[lun] = fun;
 
 	return EOK;
@@ -300,10 +348,12 @@
 
 /** USB mass storage driver ops. */
-static usb_driver_ops_t usbmast_driver_ops = {
-	.add_device = usbmast_add_device,
+static const usb_driver_ops_t usbmast_driver_ops = {
+	.device_add = usbmast_device_add,
+	.device_rem = usbmast_device_remove,
+	.device_gone = usbmast_device_gone,
 };
 
 /** USB mass storage driver. */
-static usb_driver_t usbmast_driver = {
+static const usb_driver_t usbmast_driver = {
 	.name = NAME,
 	.ops = &usbmast_driver_ops,
Index: uspace/drv/bus/usb/usbmast/usbmast.h
===================================================================
--- uspace/drv/bus/usb/usbmast/usbmast.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/usbmast/usbmast.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -41,5 +41,5 @@
 
 /** Mass storage device. */
-typedef struct {
+typedef struct usbmast_dev {
 	/** DDF device */
 	ddf_dev_t *ddf_dev;
@@ -47,6 +47,9 @@
 	usb_device_t *usb_dev;
 	/** Number of LUNs */
-	unsigned luns;
+	unsigned lun_count;
+	/** LUN functions */
+	ddf_fun_t **luns;
 } usbmast_dev_t;
+
 
 /** Mass storage function.
Index: uspace/drv/bus/usb/usbmid/dump.c
===================================================================
--- uspace/drv/bus/usb/usbmid/dump.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/usbmid/dump.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -47,10 +47,10 @@
  * @param depth Nesting depth.
  */
-static void dump_tree_descriptor(uint8_t *data, size_t depth)
+static void dump_tree_descriptor(const uint8_t *data, size_t depth)
 {
 	if (data == NULL) {
 		return;
 	}
-	int type = (int) *(data + 1);
+	const int type = data[1];
 	if (type == USB_DESCTYPE_INTERFACE) {
 		usb_standard_interface_descriptor_t *descriptor
@@ -71,6 +71,7 @@
  * @param depth Nesting depth.
  */
-static void dump_tree_internal(usb_dp_parser_t *parser, usb_dp_parser_data_t *data,
-    uint8_t *root, size_t depth)
+static void dump_tree_internal(
+    usb_dp_parser_t *parser, usb_dp_parser_data_t *data,
+    const uint8_t *root, size_t depth)
 {
 	if (root == NULL) {
@@ -78,5 +79,5 @@
 	}
 	dump_tree_descriptor(root, depth);
-	uint8_t *child = usb_dp_get_nested_descriptor(parser, data, root);
+	const uint8_t *child = usb_dp_get_nested_descriptor(parser, data, root);
 	do {
 		dump_tree_internal(parser, data, child, depth + 1);
@@ -92,5 +93,5 @@
 static void dump_tree(usb_dp_parser_t *parser, usb_dp_parser_data_t *data)
 {
-	uint8_t *ptr = data->data;
+	const uint8_t *ptr = data->data;
 	dump_tree_internal(parser, data, ptr, 0);
 }
Index: uspace/drv/bus/usb/usbmid/explore.c
===================================================================
--- uspace/drv/bus/usb/usbmid/explore.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/usbmid/explore.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -54,9 +54,8 @@
  * @return Interface @p interface_no is already present in the list.
  */
-static bool interface_in_list(list_t *list, int interface_no)
+static bool interface_in_list(const list_t *list, int interface_no)
 {
 	list_foreach(*list, l) {
-		usbmid_interface_t *iface
-		    = list_get_instance(l, usbmid_interface_t, link);
+		usbmid_interface_t *iface = usbmid_interface_from_link(l);
 		if (iface->interface_no == interface_no) {
 			return true;
@@ -73,8 +72,8 @@
  * @param list List where to add the interfaces.
  */
-static void create_interfaces(uint8_t *config_descriptor,
+static void create_interfaces(const uint8_t *config_descriptor,
     size_t config_descriptor_size, list_t *list)
 {
-	usb_dp_parser_data_t data = {
+	const usb_dp_parser_data_t data = {
 		.data = config_descriptor,
 		.size = config_descriptor_size,
@@ -82,47 +81,43 @@
 	};
 
-	usb_dp_parser_t parser = {
+	static const usb_dp_parser_t parser = {
 		.nesting = usb_dp_standard_descriptor_nesting
 	};
 
-	uint8_t *interface_ptr = usb_dp_get_nested_descriptor(&parser, &data,
-	    data.data);
-	if (interface_ptr == NULL) {
-		return;
-	}
-
-	do {
-		if (interface_ptr[1] != USB_DESCTYPE_INTERFACE) {
-			goto next_descriptor;
-		}
-
-		usb_standard_interface_descriptor_t *interface
+	const uint8_t *interface_ptr =
+	    usb_dp_get_nested_descriptor(&parser, &data, config_descriptor);
+
+	/* Walk all descriptors nested in the current configuration decriptor;
+	 * i.e. all interface descriptors. */
+	for (;interface_ptr != NULL;
+	    interface_ptr = usb_dp_get_sibling_descriptor(
+	        &parser, &data, config_descriptor, interface_ptr))
+	{
+		/* The second byte is DESCTYPE byte in all desriptors. */
+		if (interface_ptr[1] != USB_DESCTYPE_INTERFACE)
+			continue;
+
+		const usb_standard_interface_descriptor_t *interface
 		    = (usb_standard_interface_descriptor_t *) interface_ptr;
 
 		/* Skip alternate interfaces. */
-		if (!interface_in_list(list, interface->interface_number)) {
-			usbmid_interface_t *iface
-			    = malloc(sizeof(usbmid_interface_t));
-			if (iface == NULL) {
-				break;
-			}
-			link_initialize(&iface->link);
-			iface->fun = NULL;
-			iface->interface_no = interface->interface_number;
-			iface->interface = interface;
-
-			list_append(&iface->link, list);
-		}
-
-		/* TODO: add the alternatives and create match ids from them
-		 * as well.
-		 */
-
-next_descriptor:
-		interface_ptr = usb_dp_get_sibling_descriptor(&parser, &data,
-		    data.data, interface_ptr);
-
-	} while (interface_ptr != NULL);
-
+		if (interface_in_list(list, interface->interface_number)) {
+			/* TODO: add the alternatives and create match ids
+			 * for them. */
+			continue;
+		}
+		usbmid_interface_t *iface = malloc(sizeof(usbmid_interface_t));
+		if (iface == NULL) {
+			//TODO: Do something about that failure.
+			break;
+		}
+
+		link_initialize(&iface->link);
+		iface->fun = NULL;
+		iface->interface_no = interface->interface_number;
+		iface->interface = interface;
+
+		list_append(&iface->link, list);
+	}
 }
 
@@ -139,18 +134,19 @@
 	int rc;
 
-	int dev_class = dev->descriptors.device.device_class;
+	unsigned dev_class = dev->descriptors.device.device_class;
 	if (dev_class != USB_CLASS_USE_INTERFACE) {
 		usb_log_warning(
-		    "Device class: %d (%s), but expected class 0.\n",
-		    dev_class, usb_str_class(dev_class));
+		    "Device class: %u (%s), but expected class %u.\n",
+		    dev_class, usb_str_class(dev_class),
+		    USB_CLASS_USE_INTERFACE);
 		usb_log_error("Not multi interface device, refusing.\n");
 		return false;
 	}
 
-	/* Short cuts to save on typing ;-). */
-	uint8_t *config_descriptor_raw = dev->descriptors.configuration;
+	/* Shortcuts to save on typing ;-). */
+	const void *config_descriptor_raw = dev->descriptors.configuration;
 	size_t config_descriptor_size = dev->descriptors.configuration_size;
-	usb_standard_configuration_descriptor_t *config_descriptor =
-	    (usb_standard_configuration_descriptor_t *) config_descriptor_raw;
+	const usb_standard_configuration_descriptor_t *config_descriptor =
+	    config_descriptor_raw;
 
 	/* Select the first configuration */
@@ -163,32 +159,40 @@
 	}
 
-	/* Create control function */
-	ddf_fun_t *ctl_fun = ddf_fun_create(dev->ddf_dev, fun_exposed, "ctl");
-	if (ctl_fun == NULL) {
+	/* Create driver soft-state. */
+	usb_mid_t *usb_mid = usb_device_data_alloc(dev, sizeof(usb_mid_t));
+	if (!usb_mid) {
+		usb_log_error("Failed to create USB MID structure.\n");
+		return false;
+	}
+
+	/* Create control function. */
+	usb_mid->ctl_fun = ddf_fun_create(dev->ddf_dev, fun_exposed, "ctl");
+	if (usb_mid->ctl_fun == NULL) {
 		usb_log_error("Failed to create control function.\n");
 		return false;
 	}
-
-	ctl_fun->ops = &mid_device_ops;
-
-	rc = ddf_fun_bind(ctl_fun);
+	usb_mid->ctl_fun->ops = &mid_device_ops;
+
+	/* Bind control function. */
+	rc = ddf_fun_bind(usb_mid->ctl_fun);
 	if (rc != EOK) {
 		usb_log_error("Failed to bind control function: %s.\n",
 		    str_error(rc));
-		return false;
-	}
+		ddf_fun_destroy(usb_mid->ctl_fun);
+		return false;
+	}
+
 
 	/* Create interface children. */
-	list_t interface_list;
-	list_initialize(&interface_list);
+	list_initialize(&usb_mid->interface_list);
 	create_interfaces(config_descriptor_raw, config_descriptor_size,
-	    &interface_list);
-
-	list_foreach(interface_list, link) {
-		usbmid_interface_t *iface = list_get_instance(link,
-		    usbmid_interface_t, link);
+	    &usb_mid->interface_list);
+
+	/* Start child function for every interface. */
+	list_foreach(usb_mid->interface_list, link) {
+		usbmid_interface_t *iface = usbmid_interface_from_link(link);
 
 		usb_log_info("Creating child for interface %d (%s).\n",
-		    (int) iface->interface_no,
+		    iface->interface_no,
 		    usb_str_class(iface->interface->interface_class));
 
Index: uspace/drv/bus/usb/usbmid/main.c
===================================================================
--- uspace/drv/bus/usb/usbmid/main.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/usbmid/main.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -49,5 +49,5 @@
  * @return Error code.
  */
-static int usbmid_add_device(usb_device_t *dev)
+static int usbmid_device_add(usb_device_t *dev)
 {
 	usb_log_info("Taking care of new MID `%s'.\n", dev->ddf_dev->name);
@@ -65,12 +65,114 @@
 	return EOK;
 }
+/*----------------------------------------------------------------------------*/
+/** Callback when a MID device is about to be removed from the host.
+ *
+ * @param dev USB device representing the removed device.
+ * @return Error code.
+ */
+static int usbmid_device_remove(usb_device_t *dev)
+{
+	assert(dev);
+	usb_mid_t *usb_mid = dev->driver_data;
+	assert(usb_mid);
+
+	/* Remove ctl function */
+	int ret = ddf_fun_unbind(usb_mid->ctl_fun);
+	if (ret != EOK) {
+		usb_log_error("Failed to unbind USB MID ctl function: %s.\n",
+		    str_error(ret));
+		return ret;
+	}
+	ddf_fun_destroy(usb_mid->ctl_fun);
+
+	/* Remove all children */
+	while (!list_empty(&usb_mid->interface_list)) {
+		link_t *item = list_first(&usb_mid->interface_list);
+		list_remove(item);
+
+		usbmid_interface_t *iface = usbmid_interface_from_link(item);
+
+		usb_log_info("Removing child for interface %d (%s).\n",
+		    iface->interface_no,
+		    usb_str_class(iface->interface->interface_class));
+
+		/* Tell the child to go off-line. */
+		int pret = ddf_fun_offline(iface->fun);
+		if (pret != EOK) {
+			usb_log_warning("Failed to turn off child for interface"
+			    " %d (%s): %s\n", iface->interface_no,
+			    usb_str_class(iface->interface->interface_class),
+			    str_error(pret));
+			ret = pret;
+		}
+
+		/* Now remove the child. */
+		pret = usbmid_interface_destroy(iface);
+		if (pret != EOK) {
+			usb_log_error("Failed to destroy child for interface "
+			    "%d (%s): %s\n", iface->interface_no,
+			    usb_str_class(iface->interface->interface_class),
+			    str_error(pret));
+			ret = pret;
+		}
+	}
+	return ret;
+}
+/*----------------------------------------------------------------------------*/
+/** Callback when a MID device was removed from the host.
+ *
+ * @param dev USB device representing the removed device.
+ * @return Error code.
+ */
+static int usbmid_device_gone(usb_device_t *dev)
+{
+	assert(dev);
+	usb_mid_t *usb_mid = dev->driver_data;
+	assert(usb_mid);
+
+	usb_log_info("USB MID gone: `%s'.\n", dev->ddf_dev->name);
+
+	/* Remove ctl function */
+	int ret = ddf_fun_unbind(usb_mid->ctl_fun);
+	if (ret != EOK) {
+		usb_log_error("Failed to unbind USB MID ctl function: %s.\n",
+		    str_error(ret));
+		return ret;
+	}
+	ddf_fun_destroy(usb_mid->ctl_fun);
+
+	/* Now remove all other functions */
+	while (!list_empty(&usb_mid->interface_list)) {
+		link_t *item = list_first(&usb_mid->interface_list);
+		list_remove(item);
+
+		usbmid_interface_t *iface = usbmid_interface_from_link(item);
+
+		usb_log_info("Child for interface %d (%s) gone.\n",
+		    iface->interface_no,
+		    usb_str_class(iface->interface->interface_class));
+
+		const int pret = usbmid_interface_destroy(iface);
+		if (pret != EOK) {
+			usb_log_error("Failed to remove child for interface "
+			    "%d (%s): %s\n",
+			    iface->interface_no,
+			    usb_str_class(iface->interface->interface_class),
+			    str_error(pret));
+			ret = pret;
+		}
+	}
+	return ret;
+}
 
 /** USB MID driver ops. */
-static usb_driver_ops_t mid_driver_ops = {
-	.add_device = usbmid_add_device,
+static const usb_driver_ops_t mid_driver_ops = {
+	.device_add = usbmid_device_add,
+	.device_rem = usbmid_device_remove,
+	.device_gone = usbmid_device_gone,
 };
 
 /** USB MID driver. */
-static usb_driver_t mid_driver = {
+static const usb_driver_t mid_driver = {
 	.name = NAME,
 	.ops = &mid_driver_ops,
Index: uspace/drv/bus/usb/usbmid/usbmid.c
===================================================================
--- uspace/drv/bus/usb/usbmid/usbmid.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/usbmid/usbmid.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -45,13 +45,5 @@
 
 /** Callback for DDF USB interface. */
-static int usb_iface_get_address_impl(ddf_fun_t *fun, devman_handle_t handle,
-    usb_address_t *address)
-{
-	return usb_iface_get_address_hub_impl(fun, handle, address);
-}
-
-/** Callback for DDF USB interface. */
-static int usb_iface_get_interface_impl(ddf_fun_t *fun, devman_handle_t handle,
-    int *iface_no)
+static int usb_iface_get_interface_impl(ddf_fun_t *fun, int *iface_no)
 {
 	assert(fun);
@@ -69,7 +61,7 @@
 /** DDF interface of the child - interface function. */
 static usb_iface_t child_usb_iface = {
-	.get_hc_handle = usb_iface_get_hc_handle_hub_child_impl,
-	.get_address = usb_iface_get_address_impl,
-	.get_interface = usb_iface_get_interface_impl
+	.get_hc_handle = usb_iface_get_hc_handle_device_impl,
+	.get_my_address = usb_iface_get_my_address_forward_impl,
+	.get_my_interface = usb_iface_get_interface_impl,
 };
 
@@ -79,4 +71,19 @@
 };
 
+int usbmid_interface_destroy(usbmid_interface_t *mid_iface)
+{
+	assert(mid_iface);
+	assert_link_not_used(&mid_iface->link);
+	const int ret = ddf_fun_unbind(mid_iface->fun);
+	if (ret != EOK) {
+		return ret;
+	}
+	/* NOTE: usbmid->interface points somewhere, but we did not
+	 * allocate that space, so don't touch */
+	ddf_fun_destroy(mid_iface->fun);
+	/* NOTE: mid_iface is invalid at this point, it was assigned to
+	 * mid_iface->fun->driver_data and freed in ddf_fun_destroy */
+	return EOK;
+}
 
 /** Spawn new child device from one interface.
@@ -102,48 +109,37 @@
 	 * class name something humanly understandable.
 	 */
-	rc = asprintf(&child_name, "%s%d",
+	rc = asprintf(&child_name, "%s%hhu",
 	    usb_str_class(interface_descriptor->interface_class),
-	    (int) interface_descriptor->interface_number);
+	    interface_descriptor->interface_number);
 	if (rc < 0) {
-		goto error_leave;
+		return ENOMEM;
 	}
 
 	/* Create the device. */
 	child = ddf_fun_create(parent->ddf_dev, fun_inner, child_name);
+	free(child_name);
 	if (child == NULL) {
-		rc = ENOMEM;
-		goto error_leave;
+		return ENOMEM;
 	}
 
-	iface->fun = child;
-
-	child->driver_data = iface;
-	child->ops = &child_device_ops;
-
 	rc = usb_device_create_match_ids_from_interface(device_descriptor,
-	    interface_descriptor,
-	    &child->match_ids);
+	    interface_descriptor, &child->match_ids);
 	if (rc != EOK) {
-		goto error_leave;
+		ddf_fun_destroy(child);
+		return rc;
 	}
 
 	rc = ddf_fun_bind(child);
 	if (rc != EOK) {
-		goto error_leave;
+		/* This takes care of match_id deallocation as well. */
+		ddf_fun_destroy(child);
+		return rc;
 	}
 
+	iface->fun = child;
+	child->driver_data = iface;
+	child->ops = &child_device_ops;
+
 	return EOK;
-
-error_leave:
-	if (child != NULL) {
-		child->name = NULL;
-		/* This takes care of match_id deallocation as well. */
-		ddf_fun_destroy(child);
-	}
-	if (child_name != NULL) {
-		free(child_name);
-	}
-
-	return rc;
 }
 
Index: uspace/drv/bus/usb/usbmid/usbmid.h
===================================================================
--- uspace/drv/bus/usb/usbmid/usbmid.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/usbmid/usbmid.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -51,5 +51,5 @@
 	ddf_fun_t *fun;
 	/** Interface descriptor. */
-	usb_standard_interface_descriptor_t *interface;
+	const usb_standard_interface_descriptor_t *interface;
 	/** Interface number. */
 	int interface_no;
@@ -58,4 +58,10 @@
 } usbmid_interface_t;
 
+/** Container to hold all the function pointers */
+typedef struct usb_mid {
+	ddf_fun_t *ctl_fun;
+	list_t interface_list;
+} usb_mid_t;
+
 bool usbmid_explore_device(usb_device_t *);
 int usbmid_spawn_interface_child(usb_device_t *, usbmid_interface_t *,
@@ -63,4 +69,10 @@
     const usb_standard_interface_descriptor_t *);
 void usbmid_dump_descriptors(uint8_t *, size_t);
+int usbmid_interface_destroy(usbmid_interface_t *mid_iface);
+
+static inline usbmid_interface_t * usbmid_interface_from_link(link_t *item)
+{
+	return list_get_instance(item, usbmid_interface_t, link);
+}
 
 #endif
Index: uspace/drv/bus/usb/vhc/connhost.c
===================================================================
--- uspace/drv/bus/usb/vhc/connhost.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/vhc/connhost.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -57,20 +57,12 @@
  * @return Error code.
  */
-static int request_address(ddf_fun_t *fun, usb_speed_t speed,
-    usb_address_t *address)
-{
-	VHC_DATA(vhc, fun);
-
-	usb_address_t addr = usb_device_manager_get_free_address(
-	    &vhc->dev_manager, USB_SPEED_HIGH);
-	if (addr < 0) {
-		return addr;
-	}
-
-	if (address != NULL) {
-		*address = addr;
-	}
-
-	return EOK;
+static int request_address(ddf_fun_t *fun, usb_address_t *address, bool strict,
+    usb_speed_t speed)
+{
+	VHC_DATA(vhc, fun);
+
+	assert(address);
+	return usb_device_manager_request_address(
+	    &vhc->dev_manager, address, strict, speed);
 }
 
@@ -88,5 +80,5 @@
 	usb_log_debug("Binding handle %" PRIun " to address %d.\n",
 	    handle, address);
-	usb_device_manager_bind(&vhc->dev_manager, address, handle);
+	usb_device_manager_bind_address(&vhc->dev_manager, address, handle);
 
 	return EOK;
@@ -104,7 +96,6 @@
 {
 	VHC_DATA(vhc, fun);
-	bool found =
-	    usb_device_manager_find_by_address(&vhc->dev_manager, address, handle);
-	return found ? EOK : ENOENT;
+	return usb_device_manager_get_info_by_address(
+	    &vhc->dev_manager, address, handle, NULL);
 }
 
@@ -119,5 +110,5 @@
 	VHC_DATA(vhc, fun);
 	usb_log_debug("Releasing address %d...\n", address);
-	usb_device_manager_release(&vhc->dev_manager, address);
+	usb_device_manager_release_address(&vhc->dev_manager, address);
 
 	return ENOTSUP;
@@ -137,24 +128,14 @@
  */
 static int register_endpoint(ddf_fun_t *fun,
-    usb_address_t address, usb_speed_t speed, usb_endpoint_t endpoint,
+    usb_address_t address, usb_endpoint_t endpoint,
     usb_transfer_type_t transfer_type, usb_direction_t direction,
     size_t max_packet_size, unsigned int interval)
 {
-	/* TODO: Use usb_endpoint_manager_add_ep */
-	VHC_DATA(vhc, fun);
-
-	endpoint_t *ep = endpoint_get(
-	    address, endpoint, direction, transfer_type, USB_SPEED_FULL, 1);
-	if (ep == NULL) {
-		return ENOMEM;
-	}
-
-	int rc = usb_endpoint_manager_register_ep(&vhc->ep_manager, ep, 1);
-	if (rc != EOK) {
-		endpoint_destroy(ep);
-		return rc;
-	}
-
-	return EOK;
+	VHC_DATA(vhc, fun);
+
+	return usb_endpoint_manager_add_ep(&vhc->ep_manager,
+	    address, endpoint, direction, transfer_type, USB_SPEED_FULL, 1, 0,
+	    NULL, NULL);
+
 }
 
@@ -172,6 +153,6 @@
 	VHC_DATA(vhc, fun);
 
-	int rc = usb_endpoint_manager_unregister_ep(&vhc->ep_manager,
-	    address, endpoint, direction);
+	int rc = usb_endpoint_manager_remove_ep(&vhc->ep_manager,
+	    address, endpoint, direction, NULL, NULL);
 
 	return rc;
@@ -414,6 +395,6 @@
 	VHC_DATA(vhc, fun);
 
-	endpoint_t *ep = usb_endpoint_manager_get_ep(&vhc->ep_manager,
-	    target.address, target.endpoint, USB_DIRECTION_IN, NULL);
+	endpoint_t *ep = usb_endpoint_manager_find_ep(&vhc->ep_manager,
+	    target.address, target.endpoint, USB_DIRECTION_IN);
 	if (ep == NULL) {
 		return ENOENT;
@@ -440,5 +421,7 @@
 	int rc = vhc_virtdev_add_transfer(vhc, transfer);
 	if (rc != EOK) {
-		free(transfer->setup_buffer);
+		if (transfer->setup_buffer != NULL) {
+			free(transfer->setup_buffer);
+		}
 		free(transfer);
 		return rc;
@@ -454,6 +437,6 @@
 	VHC_DATA(vhc, fun);
 
-	endpoint_t *ep = usb_endpoint_manager_get_ep(&vhc->ep_manager,
-	    target.address, target.endpoint, USB_DIRECTION_OUT, NULL);
+	endpoint_t *ep = usb_endpoint_manager_find_ep(&vhc->ep_manager,
+	    target.address, target.endpoint, USB_DIRECTION_OUT);
 	if (ep == NULL) {
 		return ENOENT;
@@ -488,6 +471,5 @@
 }
 
-static int tell_address(ddf_fun_t *fun, devman_handle_t handle,
-    usb_address_t *address)
+static int tell_address(ddf_fun_t *fun, usb_address_t *address)
 {
 	UNSUPPORTED("tell_address");
@@ -506,15 +488,13 @@
 }
 
-static int tell_address_rh(ddf_fun_t *root_hub_fun, devman_handle_t handle,
-    usb_address_t *address)
+static int tell_address_rh(ddf_fun_t *root_hub_fun, usb_address_t *address)
 {
 	VHC_DATA(vhc, root_hub_fun);
 
-	if (handle == 0) {
-		handle = root_hub_fun->handle;
-	}
+	devman_handle_t handle = root_hub_fun->handle;
 
 	usb_log_debug("tell_address_rh(handle=%" PRIun ")\n", handle);
-	usb_address_t addr = usb_device_manager_find(&vhc->dev_manager, handle);
+	const usb_address_t addr =
+	    usb_device_manager_find_address(&vhc->dev_manager, handle);
 	if (addr < 0) {
 		return addr;
@@ -528,5 +508,5 @@
 	.request_address = request_address,
 	.bind_address = bind_address,
-	.find_by_address = find_by_address,
+	.get_handle = find_by_address,
 	.release_address = release_address,
 
@@ -540,10 +520,10 @@
 usb_iface_t vhc_usb_iface = {
 	.get_hc_handle = usb_iface_get_hc_handle_hc_impl,
-	.get_address = tell_address
+	.get_my_address = tell_address
 };
 
 usb_iface_t rh_usb_iface = {
 	.get_hc_handle = usb_iface_get_hc_handle_rh_impl,
-	.get_address = tell_address_rh
+	.get_my_address = tell_address_rh
 };
 
Index: uspace/drv/bus/usb/vhc/hub.c
===================================================================
--- uspace/drv/bus/usb/vhc/hub.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/vhc/hub.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -81,5 +81,5 @@
 }
 
-static int pretend_port_rest(int unused, void *unused2)
+static int pretend_port_rest(void *unused2)
 {
 	return EOK;
@@ -114,8 +114,6 @@
 
 	ddf_fun_t *hub_dev;
-	rc = usb_hc_new_device_wrapper(hc_dev->dev, &hc_conn,
-	    USB_SPEED_FULL,
-	    pretend_port_rest, 0, NULL,
-	    NULL, NULL, &rh_ops, hc_dev, &hub_dev);
+	rc = usb_hc_new_device_wrapper(hc_dev->dev, &hc_conn, USB_SPEED_FULL,
+	    pretend_port_rest, NULL, NULL, &rh_ops, hc_dev, &hub_dev);
 	if (rc != EOK) {
 		usb_log_fatal("Failed to create root hub: %s.\n",
Index: uspace/drv/bus/usb/vhc/main.c
===================================================================
--- uspace/drv/bus/usb/vhc/main.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/vhc/main.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -58,5 +58,5 @@
 };
 
-static int vhc_add_device(ddf_dev_t *dev)
+static int vhc_dev_add(ddf_dev_t *dev)
 {
 	static int vhc_count = 0;
@@ -80,5 +80,5 @@
 		return rc;
 	}
-	usb_device_manager_init(&data->dev_manager);
+	usb_device_manager_init(&data->dev_manager, USB_SPEED_MAX);
 
 	ddf_fun_t *hc = ddf_fun_create(dev, fun_exposed, "hc");
@@ -131,5 +131,5 @@
 
 static driver_ops_t vhc_driver_ops = {
-	.add_device = vhc_add_device,
+	.dev_add = vhc_dev_add,
 };
 
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/char/ns8250/ns8250.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -223,10 +223,10 @@
 };
 
-static int ns8250_add_device(ddf_dev_t *dev);
+static int ns8250_dev_add(ddf_dev_t *dev);
 static int ns8250_dev_remove(ddf_dev_t *dev);
 
 /** The serial port device driver's standard operations. */
 static driver_ops_t ns8250_ops = {
-	.add_device = &ns8250_add_device,
+	.dev_add = &ns8250_dev_add,
 	.dev_remove = &ns8250_dev_remove
 };
@@ -717,5 +717,5 @@
 }
 
-/** The add_device callback method of the serial port driver.
+/** The dev_add callback method of the serial port driver.
  *
  * Probe and initialize the newly added device.
@@ -723,5 +723,5 @@
  * @param dev		The serial port device.
  */
-static int ns8250_add_device(ddf_dev_t *dev)
+static int ns8250_dev_add(ddf_dev_t *dev)
 {
 	ns8250_t *ns = NULL;
@@ -730,5 +730,5 @@
 	int rc;
 	
-	ddf_msg(LVL_DEBUG, "ns8250_add_device %s (handle = %d)",
+	ddf_msg(LVL_DEBUG, "ns8250_dev_add %s (handle = %d)",
 	    dev->name, (int) dev->handle);
 	
Index: uspace/drv/infrastructure/root/root.c
===================================================================
--- uspace/drv/infrastructure/root/root.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/infrastructure/root/root.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -66,5 +66,5 @@
 #define VIRTUAL_FUN_MATCH_SCORE 100
 
-static int root_add_device(ddf_dev_t *dev);
+static int root_dev_add(ddf_dev_t *dev);
 static int root_fun_online(ddf_fun_t *fun);
 static int root_fun_offline(ddf_fun_t *fun);
@@ -72,5 +72,5 @@
 /** The root device driver's standard operations. */
 static driver_ops_t root_ops = {
-	.add_device = &root_add_device,
+	.dev_add = &root_dev_add,
 	.fun_online = &root_fun_online,
 	.fun_offline = &root_fun_offline
@@ -198,7 +198,7 @@
  *			of HW and pseudo devices).
  */
-static int root_add_device(ddf_dev_t *dev)
-{
-	ddf_msg(LVL_DEBUG, "root_add_device, device handle=%" PRIun,
+static int root_dev_add(ddf_dev_t *dev)
+{
+	ddf_msg(LVL_DEBUG, "root_dev_add, device handle=%" PRIun,
 	    dev->handle);
 
Index: uspace/drv/infrastructure/rootmac/rootmac.c
===================================================================
--- uspace/drv/infrastructure/rootmac/rootmac.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/infrastructure/rootmac/rootmac.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -125,5 +125,5 @@
  *
  */
-static int rootmac_add_device(ddf_dev_t *dev)
+static int rootmac_dev_add(ddf_dev_t *dev)
 {
 	/* Register functions */
@@ -136,5 +136,5 @@
 /** The root device driver's standard operations. */
 static driver_ops_t rootmac_ops = {
-	.add_device = &rootmac_add_device
+	.dev_add = &rootmac_dev_add
 };
 
